#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"
#define chmyax(a, b) a = max(a, b)
#define chmyin(a, b) a = min(a, b)

ll get_dist(const pair<ll, ll> &first, const pair<ll, ll> &second) {
  return second.first - first.first + second.second - first.second;
}

struct SegmentTree {
  vector<ll> vertices;
  ll N;
  void build(ll n) {
    N = n;
    vertices.assign(4 * N, 0);
  }
  ll get(ll ql, ll qr) { return _get(1, 0, N - 1, ql, qr); }
  ll _get(ll v, ll l, ll r, ll ql, ll qr) {
    if (ql > qr)
      return 0;
    if (l == ql && r == qr) {
      return vertices[v];
    }
    ll m = (l + r) / 2;
    return max(_get(v * 2, l, m, ql, min(qr, m)),
               _get(v * 2 + 1, m + 1, r, max(ql, m + 1), qr));
  }
  void update(ll ind, ll val) { _update(1, 0, N - 1, ind, val); }
  void _update(ll v, ll l, ll r, ll ind, ll val) {
    if (l == r) {
      chmyax(vertices[v], val);
      return;
    }
    ll m = (l + r) / 2;
    if (ind <= m) {
      _update(v * 2, l, m, ind, val);
    } else {
      _update(v * 2 + 1, m + 1, r, ind, val);
    }
    vertices[v] = max(vertices[v * 2], vertices[v * 2 + 1]);
  }
};

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  // freopen("in", "r", stdin);
  ll a, b, c, d, e, f, g;
  ll n, m, k;
  char ch;
  string str;
  map<pair<ll, ll>, ll> mp;
  ll p;
  cin >> n >> p;
  vector<pair<pair<ll, ll>, ll>> trampolines(2 * p + 1); // bool is_starting
  vector<ll> trampoline_answers(p + 1);
  vector<ll> comp_prep(2 * p + 2);
  for (ll i = 0; i < p; i++) {
    cin >> a >> b >> c >> d;
    trampolines[2 * i + 1] = {{a, b}, 2 * i + 1};
    trampolines[2 * i] = {{c, d}, 2 * i};
    comp_prep[i * 2 + 1] = b;
    comp_prep[i * 2 + 2] = d;
  }

  comp_prep[0] = 0;
  comp_prep[2 * p + 1] = n;
  sort(all(comp_prep));
  ll last = -1;
  vector<ll> compress;
  for (ll i = 0; i <= 2 * p + 1; i++) {
    if (last == comp_prep[i])
      continue;
    compress.push_back(comp_prep[i]);
    last = comp_prep[i];
  }
  ll CMP = compress.size();

  SegmentTree st;
  st.build(CMP);

  trampolines[2 * p] = {{n, n}, 2 * p + 1};
  sort(all(trampolines));
  mp[{0, 0}] = 0;
  for (ll i = 0; i <= 2 * p; i++) {
    ll compressed_height =
        upper_bound(all(compress), trampolines[i].first.second) -
        compress.begin() - 1;
    ll trampoline_num = trampolines[i].second >> 1;
    if (!(trampolines[i].second & 1)) {
      st.update(compressed_height, trampolines[i].first.first +
                                       trampolines[i].first.second -
                                       trampoline_answers[trampoline_num]);
      continue;
    }
    ll curr_val = trampolines[i].first.first + trampolines[i].first.second -
                  st.get(0, compressed_height);
    trampoline_answers[trampoline_num] = curr_val;
  }
  cout << trampoline_answers[p];
}
