#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ull unsigned long long
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"
#define chmyax(a, b) a = max(a, b)
#define chmyin(a, b) a = min(a, b)

vector<ll> dsu_par;
vector<ll> dsu_sz;

ll get(ll a) {
  if (a == dsu_par[a])
    return a;
  return dsu_par[a] = get(dsu_par[a]);
}
ll merge(ll a, ll b) {
  a = get(a);
  b = get(b);
  if (a == b)
    return false;
  if (dsu_sz[a] < b)
    swap(a, b);
  dsu_sz[a] += dsu_sz[b];
  dsu_par[b] = a;
  return true;
}

const ll MOD = 1e9 + 7;
ll binpow(ll n, ll k) {
  if (k == 0)
    return 1;
  if (k == 1)
    return n;
  ll tmp = k & 1 ? n : 1;
  ll res = binpow(n, k >> 1);
  return (((res * res) % MOD) * tmp) % MOD;
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  // freopen("in", "r", stdin);
  ll a, b, c, d, e, f, g;
  ll n, m, k;
  bool bl;
  char ch;
  cin >> n >> m;
  dsu_par.resize(n * m);
  dsu_sz.resize(n * m);
  vector<vector<bool>> pic(n, vector<bool>(m, false));
  vector<vector<ll>> group_num(n, vector<ll>(m, -1));
  ll group_cnt = 0;
  for (ll i = 0; i < n; i++) {
    for (ll j = 0; j < m; j++) {
      cin >> ch;
      if (ch == '#')
        continue;
      if (pic[i][j - 1]) {
        group_num[i][j] = group_num[i][j - 1];
      } else {
        group_num[i][j] = group_cnt++;
      }
      pic[i][j] = true;
    }
  }
  dsu_par.resize(group_cnt);
  dsu_sz.resize(group_cnt);
  for (ll i = 0; i < group_cnt; i++) {
    dsu_par[i] = i;
    dsu_sz[i] = 1;
  }
  ll ans = 1;
  ll curr_groups = 0;
  for (ll i = n - 2; i >= 1; i--) {
    vector<ll> lvl_groups;
    ll groups_changes = 0;
    vector<ll> old_groups;
    for (ll j = 1; j < m; j++) {
      if (!pic[i][j])
        continue;
      if (!pic[i][j - 1]) {
        groups_changes++;
        lvl_groups.push_back(group_num[i][j]);
      }
      if (pic[i + 1][j]) {
        ll old_one = get(group_num[i + 1][j]);
        if (merge(group_num[i + 1][j], group_num[i][j])) {
          groups_changes--;
          old_groups.push_back(old_one);
        }
      }
    }
    set<ll> tmp;
    for (auto i : lvl_groups) {
      tmp.insert(get(i));
    }
    set<ll> tmp2;
    for (auto i : old_groups) {
      tmp2.insert(i);
    }
    ans +=
        ((binpow(2, curr_groups - tmp2.size()) * (binpow(2, tmp.size()) - 1)) %
             MOD +
         2 * MOD) %
        MOD;
    curr_groups += groups_changes;
    if (ans < 0)
      ans += MOD;
    if (ans >= MOD)
      ans -= MOD;
  }
  assert(ans >= 0 && ans < MOD);
  cout << ans;
}
