#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ull unsigned long long
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"
#define chmyax(a, b) a = max(a, b)
#define chmyin(a, b) a = min(a, b)

vector<ll> dsu_par;
vector<ll> dsu_sz;
vector<ll> curr_group_ans;

ll get(ll a) {
  if (a == dsu_par[a])
    return a;
  return dsu_par[a] = get(dsu_par[a]);
}
ll merge(ll a, ll b) {
  a = get(a);
  b = get(b);
  if (a == b)
    return false;
  if (dsu_sz[a] < b)
    swap(a, b);
  dsu_sz[a] += dsu_sz[b];
  dsu_par[b] = a;
  return true;
}

const ll MOD = 1e9 + 7;
ll binpow(ll n, ll k) {
  if (k == 0)
    return 1;
  if (k == 1)
    return n;
  ll tmp = k & 1 ? n : 1;
  ll res = binpow(n, k >> 1);
  return (((res * res) % MOD) * tmp) % MOD;
}

void cpu_wait(ll s) {
  auto tm = chrono::system_clock::now();
  while (chrono::duration_cast<chrono::milliseconds>(
             chrono::system_clock::now() - tm)
             .count() < s) {
  }
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  // freopen("in", "r", stdin);
  ll a, b, c, d, e, f, g;
  ll n, m, k;
  bool bl;
  char ch;
  cin >> n >> m;
  dsu_par.resize(n * m);
  dsu_sz.resize(n * m);
  vector<vector<bool>> pic(n, vector<bool>(m, false));
  vector<vector<ll>> group_num(n, vector<ll>(m, -1));
  ll group_cnt = 0;
  for (ll i = 0; i < n; i++) {
    for (ll j = 0; j < m; j++) {
      cin >> ch;
      if (ch == '#')
        continue;
      if (pic[i][j - 1]) {
        group_num[i][j] = group_num[i][j - 1];
      } else {
        group_num[i][j] = group_cnt++;
      }
      pic[i][j] = true;
    }
  }
  vector<bool> visited(group_cnt, false);
  dsu_par.resize(group_cnt);
  dsu_sz.resize(group_cnt);
  for (ll i = 0; i < group_cnt; i++) {
    dsu_par[i] = i;
    dsu_sz[i] = 1;
  }
  vector<vector<ll>> adj(group_cnt);
  vector<ll> group_depth(group_cnt);
  ll ans = 1;
  for (ll i = n - 2; i >= 0; i--) {
    bl = true;
    for (ll j = 1; j < m - 1; j++) {
      if (!pic[i][j]) {
        bl = true;
        continue;
      }
      group_depth[group_num[i][j]] = i;
      if (!pic[i + 1][j]) {
        bl = true;
        continue;
      }
      if (!bl)
        continue;
      adj[group_num[i][j]].push_back(group_num[i + 1][j]);
      adj[group_num[i + 1][j]].push_back(group_num[i][j]);
    }
  }
  map<ll, vector<ll>> depths;
  vector<ll> reindexation(group_cnt, 0);
  vector<ll> golization(group_cnt, 0);
  ll gol_ind = 0;
  vector<ll> zhyvchykovist(group_cnt, 0);
  function<void(ll, ll)> dfs = [&](ll v, ll p) {
    depths[n + 1 - group_depth[v]].push_back(v);
    golization[gol_ind] = v;
    reindexation[v] = gol_ind++;
    for (auto i : adj[v]) {
      if (i == p)
        continue;
      visited[i] = true;
      dfs(i, v);
    }
  };
  for (ll i = 0; i < group_cnt; i++) {
    if (visited[i])
      continue;
    visited[i] = true;
    gol_ind = 0;
    dfs(i, i);
    for (auto j : depths) {
      for (auto k : j.second) {
        for (auto u : j.second) {
          if (get(u) == get(k)) {
            zhyvchykovist[u] |= zhyvchykovist[k];
            zhyvchykovist[u] |= (1ll << reindexation[k]);
            zhyvchykovist[k] |= zhyvchykovist[u];
            zhyvchykovist[k] |= (1ll << reindexation[u]);
          }
        }
        for (auto u : adj[k]) {
          if (group_depth[u] >= group_depth[k])
            continue;
          merge(u, k);
          zhyvchykovist[u] |= zhyvchykovist[k];
          zhyvchykovist[u] |= (1ll << reindexation[k]);
        }
      }
    }
    ll curr_group_ans = 0;
    for (ll j = 0; j < (1ll << gol_ind); j++) {
      bl = true;
      for (ll k = 0; k < gol_ind; k++) {
        if (j >> reindexation[k] & 1 &&
            (j & zhyvchykovist[k]) != zhyvchykovist[k]) {
          bl = false;
          break;
        }
      }
      curr_group_ans += bl;
    }
    curr_group_ans %= MOD;
    ans *= curr_group_ans;
    ans %= MOD;
    depths.clear();
  }
  cout << ans;
}
