#include <iostream>
#include <vector>
#include <queue>
#include <set>

using namespace std;
using ll = long long;

vector<bool> used;
vector<set<ll>> answers;

ll searchans(ll ind) {
	used[ind] = true;
	ll ans = 1;
	for (auto i : answers[ind]) {
		ans *= searchans(i);
		ans %= 1000000007;
	}
	return 1 + ans;
}

int main() {
	ll N, M, ans = 1;
	cin >> N >> M;
	vector<vector<char>> a(N, vector<char>(M));
	vector<vector<ll>> dp(N, vector<ll> (M, -1));
	for (ll i = N - 1; i > -1; i--) {
		for (ll j = M - 1; j > - 1; j--) {
			cin >> a[i][j];
		}
	}
	queue<pair<ll, ll>> bfs;
	ll num = -1, stnum;
	for (ll i = 0; i < N; i++) {
		stnum = num + 1;
		for (ll j = 0; j < M; j++) {
			if (a[i][j] != '#' && dp[i][j] == -1) {
				num++;
				answers.push_back({});
				bfs.push({ i, j });
			}
			ll x, y;
			while (!bfs.empty()) {
				x = bfs.front().first; y = bfs.front().second;
				if (dp[x][y] != -1 && dp[x][y] != num) {
					answers[num].insert(dp[x][y]);
					bfs.pop();
					continue;
				}
				dp[x][y] = num;
				if (dp[x + 1][y] != num && a[x + 1][y] != '#' && x + 1 <= i) {
					bfs.push({ x + 1, y });
				}
				if (dp[x - 1][y] != num && a[x - 1][y] != '#') {
					bfs.push({ x - 1, y });
				}
				if (dp[x][y + 1] != num && a[x][y + 1] != '#') {
					bfs.push({ x, y + 1 });
				}
				if (dp[x][y - 1] != num && a[x][y - 1] != '#') {
					bfs.push({ x, y - 1 });
				}
				bfs.pop();
			}
		}
		for (ll i = stnum; i <= num; i++) {
			for (ll j = stnum; j <= num; j++) {
				if (i != j) {
					for (auto k : answers[i]) {
						if (answers[j].size() > 0 && *answers[j].begin() <= k) {
							if (answers[j].count(k) != 0) {
								for (auto f : answers[j]) {
									answers[i].insert(f);
								}
								answers.erase(answers.begin() += j);
								num--;
								j--;
								break;
							}
						}
					}
				}
			}
		}
	}
	used.resize(answers.size(), false);
	for (ll i = answers.size() - 1; i > -1; i--) {
		if (!used[i]) {
			ans *= searchans(i);
			ans %= 1000000007;
		}
	}
	cout << ans << '\n';
}
//5 10
//##########
//#...#...##
//#.#...#.##
//#.#.#.#.##
//##########