#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <map>

using namespace std;
using ll = long long;

bool used[1000000000];
vector<set<ll>> answers;
map<ll, ll> eq;

ll searchans(ll ind) {
	used[ind] = true;
	ll ans = 1;
	for (auto i : answers[ind]) {
		ans *= searchans(i);
		ans %= 1000000007;
	}
	return 1 + ans;
}

int main() {
	ll N, M, ans = 1;
	cin >> N >> M;
	vector<vector<char>> a(N, vector<char>(M));
	vector<vector<ll>> dp(N, vector<ll> (M, -1));
	for (ll i = N - 1; i > -1; i--) {
		for (ll j = M - 1; j > - 1; j--) {
			cin >> a[i][j];
		}
	}
	queue<pair<ll, ll>> bfs;
	for (ll i = -1; i < 1000000; i++) {
		eq[i] = i;
	}
	ll num = -1, stnum;
	for (ll i = 0; i < N; i++) {
		stnum = num + 1;
		for (ll j = 0; j < M; j++) {
			if (a[i][j] != '#' && dp[i][j] == -1) {
				num++;
				answers.push_back({});
				bfs.push({ i, j });
			}
			ll x, y;
			while (!bfs.empty()) {
				x = bfs.front().first; y = bfs.front().second;
				if (eq[dp[x][y]] != -1 && eq[dp[x][y]] != num) {
					answers[num].insert(eq[dp[x][y]]);
					bfs.pop();
					continue;
				}
				dp[x][y] = num;
				if (eq[dp[x + 1][y]] != num && a[x + 1][y] != '#' && x + 1 <= i) {
					bfs.push({ x + 1, y });
				}
				if (eq[dp[x - 1][y]] != num && a[x - 1][y] != '#') {
					bfs.push({ x - 1, y });
				}
				if (eq[dp[x][y + 1]] != num && a[x][y + 1] != '#') {
					bfs.push({ x, y + 1 });
				}
				if (eq[dp[x][y - 1]] != num && a[x][y - 1] != '#') {
					bfs.push({ x, y - 1 });
				}
				bfs.pop();
			}
		}
		for (ll q = stnum; q <= num; q++) {
			for (ll j = stnum; j <= num; j++) {
				if (q != j && !used[q] && !used[j]) {
					for (auto k : answers[q]) {
						if (answers[j].count(k) != 0) {
							for (auto f : answers[j]) {
								answers[q].insert(f);
							}
							eq[j] = q;
							used[j] = true;
							break;
						}
					}
				}
			}
		}
	}
	for (ll i = answers.size() - 1; i > -1; i--) {
		if (!used[i]) {
			ans *= searchans(i);
			ans %= 1000000007;
		}
	}
	cout << ans << '\n';
}
//5 10
//##########
//#...#...##
//#.#...#.##
//#.#.#.#.##
//##########