#include <bits/stdc++.h>
using namespace std;

const int DIM = 1e3;
const long long mod = 1e9 + 7;

int n, m;
bool char_map[DIM][DIM];
long long q_var[DIM];
int par[DIM];

void input_char_map(){
    cin >> n >> m;
    char c;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j){
            cin >> c;
            char_map[i][j] = (c == '.');
        }

    for (int i = 0; i < m; ++i)
        par[i] = q_var[i] = -1;
}

long long mult_mod(long long A, long long B){
    return (A * B) % mod;
}

void create_set(int ind){
    par[ind] = ind;
    q_var[ind] = 1;
}

int find_root(int ind){
    if (par[ind] == -1) return -1;
    int res = ind;
    while (res != par[res])
        res = par[res];
    par[ind] = res;
    return res;
}

bool is_root(int ind){
    return ind == find_root(ind);
}

void unite_set(int ind_left, int ind_right){
    if (find_root(ind_right) == find_root(ind_left)) return;
    q_var[find_root(ind_left)] = mult_mod(q_var[find_root(ind_right)], q_var[find_root(ind_left)]);
    par[find_root(ind_right)] = find_root(ind_left);
}

void output(){
    for (int j = 0; j < m; ++j)
        cout << par[j] << ' ';
    cout << '\n';
    for (int j = 0; j < m; ++j)
        cout << q_var[j] << ' ';
    cout << '\n';
    for (int j = 0; j < m; ++j)
        cout << find_root(j) << ' ';
    cout << "\n\n";
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    input_char_map();

    for (int i = n-2; i > 0; --i){
        for (int j = 1; j < m-1; ++j)
            if (char_map[i][j]){
                if (!char_map[i+1][j])
                    create_set(j);
                else
                    par[j] = find_root(j);
                if (char_map[i][j-1])
                    unite_set(j-1, j);
            }
        for (int j = 1; j < m-1; ++j)
            if (is_root(j))
                q_var[j] = (q_var[j] + 1) % mod;

        //output();
    }
    
    int res = 1;
    for (int i = 1; i < m-1; ++i)
        if (is_root(i))
            res = mult_mod(q_var[i], res);
    
    cout << res << '\n';

    return 0;
}
