#include <bits/stdc++.h>
using namespace std;

const int DIM = 1e3;
const long long mod = 1e9 + 7;

int n, m;
bool char_map[DIM][DIM];
long long q_var[DIM];
int par[DIM];

int set_ind[DIM];
vector<pair<long long,bool>> sets;
vector<bool> were_already_inc;

void input_char_map(){
    cin >> n >> m;
    char c;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j){
            cin >> c;
            char_map[i][j] = (c == '.');
        }

    for (int i = 0; i < m; ++i)
        par[i] = q_var[i] = -1;
}

long long mult_mod(long long A, long long B){
    return (A * B) % mod;
}

void create_set(int ind){
    par[ind] = ind;
    set_ind[ind] = sets.size();
    sets.push_back({1, true});
    were_already_inc.push_back(false);

    q_var[ind] = 1;
}

int find_root(int ind){
    if (par[ind] == -1) return -1;
    int res = ind;
    while (res != par[res])
        res = par[res];
    par[ind] = res;
    set_ind[ind] = set_ind[par[ind]];
    return res;
}

bool is_root(int ind){
    return ind == find_root(ind);
}

void unite_set(int ind_left, int ind_right){
    if (find_root(ind_right) == find_root(ind_left)) return;

    sets[set_ind[find_root(ind_left)]].first = mult_mod(sets[set_ind[find_root(ind_right)]].first, sets[set_ind[find_root(ind_left)]].first);
    sets[set_ind[find_root(ind_right)]].second = false;
    set_ind[find_root(ind_right)] = set_ind[find_root(ind_left)];
    par[find_root(ind_right)] = find_root(ind_left);
}

void output(){
    for (int j = 0; j < m; ++j)
        cout << par[j] << ' ';
    cout << '\n';
    for (int j = 0; j < m; ++j)
        cout << find_root(j) << ' ';
    cout << '\n';
    for (int j = 0; j < m; ++j)
        cout << sets[set_ind[find_root(j)]].first << ' ';
    cout << "\n\n";
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    input_char_map();

    for (int i = n-2; i > 0; --i){
        for (int j = 1; j < m-1; ++j)
            if (char_map[i][j]){
                if (!char_map[i+1][j])
                    create_set(j);
                else
                    par[j] = find_root(j);
                if (char_map[i][j-1])
                    unite_set(j-1, j);
            }
        for (int j = 0; j < were_already_inc.size(); ++j)
            were_already_inc[j] = false;
        for (int j = 1; j < m-1; ++j)
            if (!were_already_inc[set_ind[find_root(j)]] && char_map[i][j]){
                sets[set_ind[find_root(j)]].first = (sets[set_ind[find_root(j)]].first + 1) % mod;
                were_already_inc[set_ind[find_root(j)]] = true;
            }

        //output();
    }

    int res = 1;
    for (pair<long long,bool> s : sets)
        if (s.second)
            res = mult_mod(res, s.first);
    
    cout << res << '\n';

    return 0;
}
