# traversal method:
# start going from bottom to top, filling every possible segment and seeing what happens?
# this is very inefficient but for now the best we can do
# check segments below ours and see if water will invade them too
# you can use recursion (probably, idk) to go up as well to maintain water level
# as is mentioned in the task description

i1 = input().split()
n, m = int(i1[0]) - 2, int(i1[1]) - 2
input() # skip first line
segmentRanges = []
for i in range(n):
    segmentRanges.append([])
for i in range(n):
    thisRow = input()[1:-1]
    emptySegments = thisRow.split("#")
    idx = 0
    for segment in emptySegments:
        sizeSeg = len(segment)
        if (sizeSeg) == 0:
            continue
        segmentRanges[n-i-1].append([idx, idx+sizeSeg-1, n-i-1])
        idx += sizeSeg + 1
totalVariants = 2 ** len(segmentRanges[0]) # precalculate the bottom row

# we'd need to try each possible segment combination in each possible row
# optimization: if we fill one segment and the entire row fills, we can skip the row immediately
# research making a function that would check if a path exists to any segment in our row
# this would probably help speed up calculations instead of having to do expensive navigation
# yes indeed checking for a path would allow us to use slightly less complex formulas and very few if not none loops!

# Gets a segment's neighbors. Very unoptimized, this needs to be optimized
# Todo: see if any lists can be converted into sets
def get_neighbors(segment, nohigherthan):
    segmentHeight = segment[2]
    contestants = []
    if segmentHeight != 0:
        contestants.extend(segmentRanges[segmentHeight - 1])
    if segmentHeight != nohigherthan:
        contestants.extend(segmentRanges[segmentHeight + 1])
    # check which ones overlap and which ones don't
    neighbors = []
    lS, rS = segment[0], segment[1]
    for contestant in contestants:
        lC, rC = contestant[0], contestant[1]
        if (lS >= lC and lS <= rC) or (rS >= lC and rS <= rC):
            neighbors.append(contestant)
    return neighbors

# Check if a path exists between two segments on the same height
# Base principle: Explore all reachable segments from source
# and see if destination is in there
def path_exists(segsource, segdest):
    nohigherthan = segsource[2] # max height
    checking_paths = [[segsource]]
    checking_path_count = 1

    # expand each path (and fork/create new ones) until none exist
    # ugh so slowwww !!!!
    while checking_path_count > 0:
        obsolete = []
        for i in range(checking_path_count):
            path = checking_paths[i]
            extended = False
            new_neighbors = get_neighbors(path[-1], nohigherthan)
            for neighbor in new_neighbors:
                if neighbor in path:
                    continue
                if neighbor == segdest:
                    return True
                newpath = []
                for oldelem in path:
                    newpath.append(oldelem)
                newpath.append(neighbor)
                checking_paths.append(newpath)
            obsolete.append(path)
        for ob in obsolete:
            checking_paths.remove(ob)
        checking_path_count = len(checking_paths)
    return False

def exponentRange(idx):
    # is the -1 needed here?
    return (2**idx)-1

for i in range(1, len(segmentRanges)):
    segmentsAtLevel = segmentRanges[i]
    segmentCount = len(segmentsAtLevel)
    # 1 2 4 8 16 32
    # Must make for any segmentCount (segmentCount == n)
    if segmentCount == 1:
        totalVariants += 1
        continue
    
    actualCount = segmentCount
    # now check in pairs (0-1, 1-2, 2-3)
    for pairIdx in range(segmentCount - 1):
        paththere = path_exists(segmentsAtLevel[pairIdx], segmentsAtLevel[pairIdx + 1])
        if paththere:
            actualCount -= 1
    # get actualcount from that funny range from above
    totalVariants += exponentRange(actualCount)

print(totalVariants)