#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <random>
#include <iomanip>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <numeric>
#include <unordered_map>

using namespace std;

#define LF '\n';
typedef long long lli;
typedef long double ld;

struct fenwick
{
    unordered_map<lli,lli> f;
    const lli N = 1e9 + 3;

    void add(lli ind, lli val) {
        ind++;
        ind = N - ind;
        for (int i = 1; i < N; i += i & -i)f[i] = max(f[i], val);
    }

    lli get(lli ind) {
        ind++;
        ind = N - ind;
        lli res = 0;
        for (int i = ind; i > 0; i -= i & -i)res = max(res, f[i]);
        return res;
    }
}f;

struct way
{
    lli x1, y1, x2, y2;
};

vector<way> v;
vector<pair<lli, lli>> ans;

void solve()
{
    lli k,n;
    cin >> k >> n;
    v.resize(n + 1);
    priority_queue<pair<pair<lli, lli>, pair<lli, lli>>> pq;
    ans.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> v[i].x1 >> v[i].y1 >> v[i].x2 >> v[i].y2;
        pq.push({ {v[i].x2,v[i].y2},{i,1} });
    }

    while (!pq.empty()) {
        lli ind = pq.top().second.first;
        lli t = pq.top().second.second;
        pq.pop();
        if (t == 1) {
            lli z = f.get(v[ind].y2);
            ans[ind].second = 2*k-v[ind].y2-v[ind].x2 - z;
            f.add(v[ind].y2, z);
            pq.push({ {v[ind].x1,v[ind].y1},{ind,2} });
        }
        else {
            lli z = f.get(v[ind].y1);
            lli z2 = 2 * k - v[ind].x2 - v[ind].y2 - ans[ind].second;
            z2 += v[ind].x2 - v[ind].x1 + v[ind].y2 - v[ind].y1;
            z = max(z, z2);
            ans[ind].first = 2 * k - v[ind].y1 - v[ind].x1 - z;
            f.add(v[ind].y1, z);
        }
    }
    lli res = k+k;
    for (int i = 1; i <= n; i++)res = min(res, v[i].x1 + v[i].y1 + ans[i].first);
    cout << res;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif 

    solve();
}

