#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <random>
#include <iomanip>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <numeric>

using namespace std;

#define LF '\n';
typedef long long lli;
typedef long double ld;

const lli N = 1e3 + 1;
const lli MOD = 1e9 + 7;
bool arr[N][N];


struct SIGMAK_DSU
{
    vector<lli> boss;
    vector<lli> sz;
    vector<lli> cnt;
    lli z = 1;
    set<lli> s;
    set<lli> s2;

    void init(lli n) {
        boss.resize(n + 1,0);
        sz.resize(n + 1, 0);
        cnt.resize(n + 1, 0);
    }

    void set_el(lli ind) {
        boss[ind] = ind;
        sz[ind] = ind;
        cnt[ind] = 1;
        s.insert(ind);
        s2.insert(ind);
    }

    lli get(lli u) {
        if (boss[u] == u)return u;
        return boss[u] = get(boss[u]);
    }

    void merge(lli u1, lli u2) {
        lli b1 = get(u1);
        lli b2 = get(u2);
        if (b1 == b2)return;
        if (sz[b1] < sz[b2])swap(b1, b2);
        cnt[b1] = (cnt[b1] * cnt[b2])%MOD;
        boss[b2] = b1;
        sz[b1] += sz[b2];
        s2.insert(b1);
        s2.erase(b2);
        s.erase(b2);
        s.erase(b1);
    }

    void update() {
        for (auto to : s)z = (z * cnt[to]) % MOD;
        for (auto to : s2)cnt[to]++;
        swap(s, s2);
        s2.clear();
    }

}dsu;

lli n, m;

lli make_ind(lli i, lli j) {
    return (i - 1) * m + j;
}

void solve()
{
    cin >> n >> m;
    dsu.init(n * m + 10);
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            char c;
            cin >> c;
            if (c == '#')arr[i][j] = 1;
        }
    }

    for (int i = n; i >= 1; i--) {
        for (int j = 1; j <= m; j++) {
            if (arr[i][j])continue;
            dsu.set_el(make_ind(i, j));
            if (arr[i + 1][j] == 0)dsu.merge(make_ind(i, j), make_ind(i + 1, j));
            if (arr[i][j - 1] == 0)dsu.merge(make_ind(i, j), make_ind(i, j - 1));
        }
        dsu.update();
    }
    cout << dsu.z;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif 

    solve();
}

